 {~ Photometric results from a graymap for Canon D60 ~}
 {~ as obtained by `decompress' by Dave Coffin, http://www.shore.net/~dcoffin ~}
 {~ using the exif info by `jhead' by Matthias Wandel,
       http://www.sentex.net/~mwandel/jhead ~}

{ options to skip tiles, tiles printing and histogram printing not 
 included in command line parameters, just the corresponding
 boolean variables exist and are preset to false (no skipping)
 -- the problem are the existing possibilities to put the parameter 
 values without any space behind the switches, so the switches are to 
 be single letters in case of file names... 
 }

Program raw2lum;
 {by Jan Hollan, Obs. and Planetarium Brno, version 0.97 2004-01-30 }
 (* Copyright (C) 2004 Jan Hollan

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *)

uses dos, 
     showrem, {unit from http://www.bsdg.org/swag/DOS/0055.PAS.html }
     str_num, un_str_m{, params}; {units by J. Hollan}

const
 version='0.97'; {ovlim treated as <=, with respect to pre-0.92, and 
                  YCGM coeff changed from .4 .1 .1 .4 to .4 .1 .4 .1}
		 {dark subtracted from oversaturated pixels as well in 0.95}
                 {colour band made for all colour-coded ppm's in 0.96, 
		what caused an index for LogCol being too large 
		for D60 and 300D; corrected in 0.97}
		 
 ovlim : word ={3980 d60}{8190}{60000}15850;  {this means overflow; but it's a nonsense in 
fact, it's just spilled signal from really overexposed pixels}
 trueov={4095 d60}{8191}{65535}32768{15862 for fuji5000};
 sideC = 32;
{ side:word = sideC ;}  {side of a monochromatic tile, chosen to match the width of 
                a shielded left band of the chip}
 sideX:word=sideC; 
 sideY:word=sideC; 
 ovlimT ='15850';
 trueovT='32768';
 sideT = '32'; 

 h10 = cl+
' raw2lum <graymap file> [options]'+cl2+
 
'writes a series of photometric tables to the standard output.' +cl2+

'The main input is a raw graymap made from a Canon D60 camera raw image *.crw'+cl;
 h20=  
'by "decompress" by David Coffin, http://www.shore.net/~dcoffin '+cl+
'or a portable graymap (*.pgm) produced by an adapted version of his "dcraw".'+cl2;

h20a=
'Auxiliary inputs can be submitted as parameters:'+cl2+

'-I <exif info file>  -- output of "jhead" by Matthias Wandel,'+cl+
'  http://www.sentex.net/~mwandel/jhead, to get exposure'+cl2;
h20b=
'-D <dark frame file>  -- image taken with the same shutter speed'+cl+
'  and ISO sensitivity, but with a covered lens, i.e. readings of an unlit chip,'+cl+
'  to be subtracted from the main image; the same image format is assumed'+cl2;

h30=
'Optional output:'+cl2;

h30a=
'-E <eps output file> -- Encapsulated PostScript file with a grid of medians'+cl+
'  of the recorded values (just of upper left green points of the Bayer matrix)'+cl+
'  and, with known exposure, with median luminances. A command'+cl;
h40=
' composite -compose Multiply <eps file> <image file> <output image with a grid>'+cl+
'  (sw from an ImageMagick suite) will put this labeled grid onto a image,'+cl+
'  which is then easy to compare with the photometry table.'+cl2;

h44=
'Another Color positions then 1 2  for  R G  (or another pattern...) etc.'+cl+ 
'                             3 4       G B'+cl2+

'-C{#### | fuji | YCGM} (BRGG and RBGG for Fuji S5000, YCGM for E2500...)'+cl2;
h45=
'-T# divider to get cd/m2, default';
h46=
'-M#:#:#[:#] Multipliers of the RGB or YCGM colors get luminance, default'+cl+
'   ';
h46a=
'-P# bitshift to diminish the pgm values, default 0'+cl+
'-S#[:#] side(s) of a tile (differing Y side is optional), default '+sideT+cl+
'-N<file name> make a new image with logarithmic color-coded luminance'+cl;
h46b=
'-G[#:#] compute veiling luminance from points in <L,U> (see below) interval'+cl+
'   assuming #:# pixel coordinates of the seeing point'+cl+
'            (default is centre of the image)'+cl;
h46c=
'-B#:# lower and upper limit of double-lines to be included in that image'+cl+
'      and computation of glare and of total flux (default is 0:infinity)'+cl+
'-W# CCDwidth / 1mm, to override ev. false Exif info'+cl;
h46d=
'-F<letter(s)> some further options:'+cl+
'   A for Averages instead of Medians of luminance for tiles,'+cl+
'   T for luminous flux densities from tiles rather than luminances'+cl2;


h47=
'Overful limit (before any dark level subtraction):'+cl2+ 

'-O# (default '+ovlimT+', something <=4095 suits Canon EOS D60)'+cl2;

h50=
'Summing the light just from 4-px-cells fitting some luminance limits:'+cl2+

'-L# -- lowest luminance / cd/m2'+cl+
'-U# --  upper luminance / cd/m2'+cl;

h60=
'  (when a dark frame is subtracted from an underexposed image,'+cl+
'  some pixel values may be negative, as well as the resulting "luminances",'+cl+
'  and the lower limit should be either unset or set above the noise level)'+cl2;

h70=
'R raises the values to power 1.5 (an option just for DMSP data)'+cl2;

h100=
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 2004;'+cl+
'ver.'+version+'; subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
'source code available at http://amper.ped.muni.cz/light/luminances)'+cl2;

R2Rc=2.242*1.23; {for Canon EOS D60, acc. to Dave Coffin}
B2Bc=1.245*0.86;   {... and *corrected acc. to the sunlit white paper}
R2Rs5000=1.73; {1.639  acc. to Dave Coffin}
B2Bs5000=1.57; {1.438  in dcraw}
RmC=0.3; GmC=0.59; BmC=0.11; {to get the photopic luminance, 
            formula from http://www.scantips.com/lumin.html }
{toCdM2=33.3;  a first guess for our camera, to arrive at luminance,
              using some images of sun and moonlit snow on 2003-02-12}
toCdM2:real=56;  {a second guess for divider for our camera, to arrive at luminance,
              using another images of sunlit paper 2003-07-09,
	      1.65 times less then the first one}


{all the following coefficients (before the obsolete ap='''' 
definition) should be possible to set by command-line parameters of 
course...}

R2R: real = R2Rc;
B2B: real = B2Bc;
Rm: real = RmC;
Gm: real = GmC;
Bm: real = BmC;

Ym: real = 0.4;
Cm: real = 0.1;
GYm: real =0.4;
Mm: real = 0.1;

LumM:array[1..4] of real=(RmC,GmC,GmC,BmC);
LumMset : boolean = false;



ap='''';

 BitmapStart: word = 76; {for some old D60 dcraw2r output}
 BitmapStartD: word = 76; {for some old D60 dcraw2r output}
 startline: byte = 12; {for EOS D60}
 lines: word = 1028; {double lines of D60 chip}
 tilerm: word = 33;  {lines div side + 1}
 linl: word  = 3152; {line length of D60}
 linlhC = 1575 {linl div 2 + -1, constant just to be able to use it in 
                  declaration} ; 
 linlh:word  = 1575 {linl div 2 + -1} ; 
 {last element on the line; their number is linlh+1 = linl/2)}
{for a useful chip size lower than 3152*(2056+12), the constants may become
variables and read either from a head of *.pgm or given on a command line}

  { tilen:=(linlh+1)  div side;
   if linlh mod side = 0 then dec(tilen); 
    is number of the last tile, the first one is 0}
 tilen: word = 49 ; 
 tilenC = 99 ; 
 lin : word = 0;
 tiler : word = 0;
 darkn : longint = 0; 
 dark : longint = 0;
 darkStrip: boolean = true; {for D60 fully raw}
 darkDFc= 512;
 darkDF : word = darkDFc; {constant added to Main-DarkFrame to be over zero mostly}
 darkConst : byte = 0; {default dark level for individual frames}
 darkmin : word = trueov;
 darkmax : word = 0;
 min : word = trueov;
 max : word = 0;
 sumt : array [1..4] of double = (0,0,0,0);
 sumN : array [1..4] of longint = (0,0,0,0);
 maxt : array [1..4] of longint = (0,0,0,0);
 mint : array [1..4] of longint = (trueov,trueov,trueov,trueov);
 osumt : array [1..4] of longint = (0,0,0,0);
 color : array [1..4] of string[4] = ('Red ','GrUp','GrDw','Blue');
 colorY : array [1..4] of string[4] = ('Yell','Cyan','Gree','Mage');
 percn = 6;
 percv : array [1..percn] of byte = (1,10,50,90,99,100);
 dist : array [1..4] of longint = (0,0,0,0);
 lsum : {array [1..4] of }double{longint} = {(}0{,0,0,0)};
 kf   : array [1..4] of byte = (1,1,1,1);
 exp_length : real =0;
 exp_frac : word =0;
 foc_ratio : real =0;
 ISO : word = 0;
 exposure : real = 1;
 exposure_known : boolean = false;
 OutputFile: string = '';
 InfoFile: string = '';
 MainFrame: string = '';
 DarkFrame: string = '';
 EpsFile: string = '';
 ParFlag: char = ' ';
 SubDF: boolean = false;
{imin: array [1..4] of word = (0,0,0,0);
 imax: array [1..4] of word = (trueov,trueov,trueov,trueov);
 iminG: array [1..4] of word = (0,0,0,0);
 imaxG: array [1..4] of word = (trueov,trueov,trueov,trueov);
 }
 minLC=-1e4; {negative value is here just for having no real lower limit} 
 maxLC=1e5;  {upper luminance limit/ cd/m2, thrice the sunlit white paper}
 minL:real=minLC; {negative value is here just for having no real lower limit} 
 maxL:real=maxLC;  {upper luminance limit/ cd/m2, thrice the sunlit white paper}
 shrB: byte = 0;  {bitshift to compensate for dcraw standard shift}
 cam : array [1..4] of byte = (1,2,3,4); {RGGB for Canon D60}
 fuji : boolean = false;  {just for fuji S5000}
 YCGM : boolean = false;
 bytesPP: byte=2; {bytes per pixel, default 2} 
 SumGlare: boolean = false;
 VeiLum: real = 0;
 DoublePixSize: real = 0.0147; {D60 size}
 D60ThumbExif: boolean = false;
 CCDwidth:real =0;
 CCDw:real =0; {overrides the exif info by command line parameter}
 TrueFocalLength:real = 0;
 PixAngSizeKnown: boolean = false;
 SeePX:real = 0;
 SeePY:real = 0;
 BaseLum:real=0.0004; {then the colour limits are almost 
  at sqrt(10)*10^n and reach
  from just a bit polluted sky to sunlit snow
  (almost: sqrt(10)=3.162277660168379332
   whereas the formulas
           LogLR:=(ln(L)-ln(BaseLum))/lnstep;
           if LogLR>39 then LogLR:=39;
	   LogL:=round(LogLR);
   mean that L=        
  	            3.1773 
   rounds still down to the lower colour 
  }
 BaseLumMin:real=0.00031774;  
 colors=5;
 colorLog: array [0..colors+2,1..3] of byte =
((0,0,1), (1,0,1), ( 0,1,1), ( 1,0,0),( 0,1,0), ( 1,1,0), (0,0,1), ( 1,1,1));
{ blue    magenta    cyan      red       green    yellow  blue,again  white }
 pow2m1: array [0..colors-1] of byte = (66,92,130,182,255);
 MakeLogImage:boolean = false;
 LogImage:string= '';
 DoTiles:boolean = true;     {false for skipping tiles and epsfile}
 DoPrintTiles:boolean = true; {false for printing tiles}
 PrintHistogram: boolean = true; {false for skipping histogram}
 LinMin:word=0;
 LinMax:word=0;
 Medians:boolean=true;
 Luminance:boolean=true;
 CommandLine:string = '';
 NonLinear: boolean=false;
 
 
var
 f,fd,LogImFile : file; 
 f1t : text;
 draw: text;
 fdesc : text;
 v : array [1..4] of word;
 vD : array [1..4] of word;
 o : array [1..4] of boolean;
 sum : array[1..4,0..tilenC] of longint;
 nsum, minv, maxv, osum : array[1..4,0..tilenC] of word{integer};
 his : array [1..4,0..trueov] of longint;
 hisd : array [1..4,0..trueov] of longint;
 hist : array [1..4,0..trueov,0..tilenC] of longint; {for one row of tiles only}
 line1 : array [0..linlhC,1..2] of word;
 line2 : array [0..linlhC,1..2] of word;
 lineD1 : array [0..linlhC,1..2] of word;
 lineD2 : array [0..linlhC,1..2] of word;
 line1B : array [0..linlhC,1..2] of byte absolute line1;
 line2B : array [0..linlhC,1..2] of byte absolute line2;
 lineD1B : array [0..linlhC,1..2] of byte absolute lineD1;
 lineD2B : array [0..linlhC,1..2] of byte absolute lineD2;
 tile, j, k, LogL: byte;
 i : word; 
 count, overdark : longint;
 perc : array [1..4,1..percn] of longint;
 tline, auxstr, Par, ParOrig, ParOrig1: string;
 tline13: string [13];
 L,R,G,B,tolumflux,FourPixSA,FourPixXS,FourPixYS,XpToD,YpToD,
 SpaceAngle,LogBase,lnStep,LogLR,tolum,R2T,G2T,B2T,
 DarkFloat,DarkE,Dark2,SqAngDist: real;
 {FoundName: PathStr;} FDir: DirStr; FName: NameStr; FExt: ExtStr;
 nonzero, Overfull, InLines: boolean;
 auxint,twoI: integer;
 LogCol : array [0..linlhC+10,1..3] of byte;

procedure help;
begin
 write(h10,h20,h20a,h20b,h30,h30a,h40,h44,
  h45,toCdM2:6:1,cl,h46);
 if fuji then 
  write(R2Rs5000*Rm:6:3,Gm:6:3,B2Bs5000*Bm:6:3)
 else
  write(R2Rc*Rm:6:3,Gm:6:3,B2Bc*Bm:6:3);
 write(cl,h46a,h46b,h46c,h46d,
 h47,h50,h60,h70,h100); halt;
end;

procedure zerosums;
begin
 sum[j][tile]:=0 ; nsum[j][tile]:=0;
 minv[j][tile]:=trueov; maxv[j][tile]:=0; osum[j][tile]:=0;
end;

procedure printTiles;
var xpix, ypix, darkDFor0 : word;
 darkA : real; {darkA is a changing estimate of dark 
                   during processing the tiles, for DarkStrip}
 overfullTile:boolean;		   
begin

inc(tiler);

ypix:= lines*2 - ((tiler-1)*sideY*2+sideY);

for tile:=0 to tilen do
begin
overfullTile:=false;
xpix:=(tile)*sideX*2+sideX;
if DarkStrip then dec(xpix,64);  {64 pixels hold just for D60!}     
for j:=1 to 4 do
 begin
  count:=nsum[j][tile]+osum[j][tile];
  if nsum[j,tile] = 0 then overfullTile:=true;
  for k:=1 to percn do {this could be done ahead, as there are just  
    4 types of tiles, but in principle defect pixels could be excluded
    in the future}
   begin
    perc[j][k]:=trunc(0.01*percv[k]*count);
   end;    
  for i:=minv[j][tile] to maxv[j][tile] do
   begin
{write(i:4,j:2,tile:3,hist[j,i,tile]:3);}
    inc(dist[j], hist[j][i][tile]);
{writeln(dist[j]:5);    }
    if kf[j]<=percn then
    if dist[j]>=perc[j][kf[j]] then 
     begin
      perc[j][kf[j]]:=i;
      inc(kf[j]);
     end; 
   end;
  while kf[j]<=percn do {for case of max-min < percn}
   begin
    perc[j][kf[j]]:=i;
    inc(kf[j]);
   end; 
 end;  
fillchar(kf,4,1);
fillchar(dist,4*4,0);

    if DoPrintTiles then
     begin
      if SubDF then darkDFor0:=darkDF else darkDFor0:=0; {before epsfile writing,
        no value is subtracted from the data, in case of no dark frame,
	raw pgm values are reported}
      write(tiler:2, tile:3, nsum[1][tile]+osum[1][tile]:5);
      for j:=1 to 4 do 
       begin
        write(minv[j][tile] - darkDFor0 :6);
        if nsum[j,tile] > 0 then
	 begin
          write(sum[j][tile] div nsum[j][tile] - darkDFor0 : 5);
	  if DarkStrip and (tile=0) then 
	   begin 
	    inc(dark,sum[j,tile]); inc(darkN,nsum[j,tile]);
            if minv[j][tile] < darkmin then darkmin:=minv[j][tile];
            if maxv[j][tile] > darkmax then darkmax:=maxv[j][tile];
	   end
	  else
	   begin
	    sumt[j]:=sumt[j]+sum[j,tile]; inc(sumN[j],nsum[j,tile]);
            if minv[j][tile] < mint[j] then mint[j]:=minv[j][tile];
            if maxv[j][tile] > maxt[j] then maxt[j]:=maxv[j][tile];
	   end;     
	 end  
	else
	 begin  
          write(sum[j][tile] : 5); {is equal to zero}
	 end; 
        if (tile>0) or (not DarkStrip) then  inc(osumt[j],osum[j][tile]);
        write(maxv[j][tile]-darkDFor0:5, osum[j][tile]:5);

       end; 
      writeln; 
    end;
    
      if exposure_known then
       begin
        if (not SubDF) and (DarkStrip) then
          darkA:=dark / darkN
        else 
	  darkA:=darkDF;
   	if Medians then  
	if YCGM then
	   {should be sped up skipping one multiplying the same way as RGB...}
	   L:=(Ym*(perc[cam[1]][3] - darkA) 
              +Cm*(perc[cam[2]][3] - darkA)
	      +GYm*(perc[cam[3]][3] - darkA)
              +Mm*(perc[cam[4]][3] - darkA) 
	      ) * tolum 
	else
 	  L:=
	   R2T*(perc[cam[1]][3] - darkA) +
	   G2T*(perc[cam[2]][3]+perc[cam[3]][3] - 2*darkA ) +
	   B2T*(perc[cam[4]][3] - darkA)
	else if not overfullTile then {averages}
	if YCGM then
	   {should be sped up skipping one multiplying the same way as RGB...}
	   L:=(Ym* (sum[cam[1]][tile] / nsum[cam[1]][tile] - darkA) 
              +Cm* (sum[cam[2]][tile] / nsum[cam[2]][tile] - darkA)  
	      +GYm*(sum[cam[3]][tile] / nsum[cam[3]][tile] - darkA)
              +Mm* (sum[cam[4]][tile] / nsum[cam[4]][tile] - darkA) 
	      ) * tolum 
	else
 	  L:=
	   R2T*(sum[cam[1]][tile] / nsum[cam[1]][tile] - darkA) +
	   G2T*(sum[cam[2]][tile] / nsum[cam[2]][tile] +
	        sum[cam[3]][tile] / nsum[cam[3]][tile] 
	        - 2*darkA) +
	   B2T*(sum[cam[4]][tile] / nsum[cam[4]][tile] - darkA)
	else L:=0;   
       end;


    if DoPrintTiles then
     begin
      if (tile>0) or (not DarkStrip) then  
        if Luminance then
         write('   ',SRxb(2,L,7))  {luminance for a lit tile}
	else {luminous flux density from a tile}
	 write('   ',SRxb(2,FourPixSA*L*(nsum[1][tile]+osum[1][tile]),7)) 
      else
        write('          ');
      for j:=1 to 4 do
       write(perc[j][2]-darkDFor0:6, 
             perc[j][3]-darkDFor0:5, 
	     perc[j][4]-darkDFor0:5,'     ');
      writeln;
     end;
                 
      if EpsFile<>'' then
      if ((tile>0) or (not DarkStrip))
      and (tiler<tilerm) then
       if tile<tilen then
        begin
         write (draw,
            xpix:4,ypix:5,' m (',
            tiler:2,') (',tile:3,') (',perc[2,3]-darkDFor0:5,') sc ' );
         if exposure_known then
          if Luminance then
           write(draw,
	    '(',SRx(2,L),') sl ')
          else {luminous flux density from a tile}
	   write(draw,
	    '(',SRx(2,FourPixSA*L*(nsum[1][tile]+osum[1][tile])),') sl '); 
         if (tile mod 2) = 1 then  {2 tiles per line}
          writeln(draw);
        end
       else {last tile, uncomplete one, plotting the horizontal line instead}     
        writeln(draw,
         ' 0 ',ypix-sideY:5,' m ',linl-1:5,ypix-sideY:5,' ls');

    for j:=1 to 4 do 
        zerosums;      

     end; { of  for tile:=0 to tilen do}

    fillchar(hist,4*4*(trueov+1)*(tilenC+1),0);
   end;

procedure captions;
 begin
        {33 49   32   137  133  142    0   147  144  153    0   149  146  155    0   145  140  149    0
}
 if YCGM then
  writeln(cl,'#c li count  min  Yav  max  ovf   ',
                     'min  Cav   max  ovf   ',
		     'min  Gav   max  ovf   ',
		     'min  Mav  max  ovf')
 else		     
  writeln(cl,'#c li count  min  Rav  max  ovf   ',
                     'min  G1   max  ovf   ',
		     'min  G2   max  ovf   ',
		     'min  Bav  max  ovf');
  writeln('#percentils:  10   50   90       etc.');	     

if exposure_known then
 if Medians then
  if Luminance then   
   writeln('# Median Luminance / 1 cd.m-2')
  else 
   writeln('# Median Luminous flux density (Brightness) / 1 lm.m-2')
 else 
  if Luminance then   
   writeln('# Average Luminance / 1 cd.m-2')
  else 
   writeln('# Average Luminous flux density (Brightness) / 1 cd.m-2');

if EpsFile<>'' then
 begin
 assign(draw,EpsFile);
 rewrite(draw);
 write(draw,
'%!PS-Adobe-3.0 EPSF-3.0',cl,
'%%BoundingBox: 0 0 ');
if DarkStrip {Canon D60 full, ppm needs smaller size} then 
 write(draw,' 3086')
else
 write(draw,linl:5);
if fuji 
then writeln(draw,lines:5,cl) {fuji jpg has really halved number of lines}
else writeln(draw,lines*2:5,cl);
 {but for Canon D60 full, ppm made by dcraw has two rows less...}

 writeln(draw, cl,
'% Results of "raw2lum" (version ', version,') with parameters:',cl,
'% ',CommandLine,cl);



writeln(draw, 
'/m {moveto} def',cl,
'/ls {lineto stroke} def',cl,
'/s {dup stringwidth 2 div exch 2 div neg exch rmoveto show} def',cl,
'/sc  {gsave 0 ',-(8*sideY) div sideC,' rmoveto L s grestore',cl,
'     gsave  0 ',(20*sideY) div sideC,' rmoveto s grestore',cl,
'     gsave ',-(30*sideX) div sideC,' ',(10*sideY) div sideC,' rmoveto show grestore} def',cl,
'/sl {0 ',(-28*sideY) div sideC,' rmoveto l s} def',cl2,

 
'/L {/Helvetica ',(16*sideY) div sideC,' selectfont} def',cl,
'/l {/Helvetica ',(14*sideY) div sideC,' selectfont} def',cl,
'l',cl);

if fuji then writeln(draw,'1 0.5 scale',cl);

if DarkStrip then k:=1 else k:=0;
 for tile:=k to tilen do
  begin  {plotting vertical lines}
   write(draw,
            tile*SideX*2:5,' 0 m',tile*SideX*2:5,lines*2-2:5,' ls');
   if (tile mod 20) = 0 then {20 tiles per line}
       writeln(draw);
  end;
 writeln(draw); 
 if SumGlare then 
  writeln(draw, 'gsave 3 setlinewidth',
          seepx*2-10:5:0,(lines-seepy)*2:5:0,' m', 
	  seepx*2+10:5:0,(lines-seepy)*2:5:0,' ls',    
          seepx*2:5:0,   (lines-seepy)*2-20:5:0,' m', 
	  seepx*2:5:0,   (lines-seepy)*2+20:5:0,' ls',
	  ' grestore' );
 end; {of creating the beginning of EpsFile} 

 end;


begin


if paramcount<1 then help
else for j:= 1 to paramcount do
 begin
  Par:=paramstr(j);
  CommandLine:=CommandLine+' '+Par;
  ParOrig:=Par;
  if ParFlag<>' ' then
   begin  {just some parameters are written to accept a blank before them}
    case ParFlag of
    'B': begin
          k:=ItemCountD(':',Par);
          if k>0 then LinMin:=I_S(ItemStrD(':',1,Par));
          if k>1 then LinMax:=I_S(ItemStrD(':',2,Par));
         end;
    'C': if Par='fuji' then fuji:=true else
	 if Par='YCGM' then YCGM:=true else
         for k:=1 to 4 do
	  cam[k]:=I_S(copy(Par,k,1)); 
    'D': DarkFrame:=Par;
    'E': EpsFile:=Par;
    'F': for k:=1 to length(par) do
	   case Par[k] of
	    'A': begin Medians:=false; Luminance:=true; end;
	    'T': begin Luminance:=false; Medians:=false; end;
	    'M': Medians:=true;
	    'L': Luminance:=true;
	   end;     
    'I': InfoFile:=Par;
    'L': minL:=R_S(Par);
    'N': LogImage:=Par;
    'O': Ovlim:=I_S(Par);
    'U': maxL:=R_S(Par);
    'P': shrB:=I_S(copy(Par,1,1));
    'S': begin
          k:=ItemCountD(':',Par);
          if k>0 then 
	   begin
	    SideX:=I_S(ItemStrD(':',1,Par));
            if k>1 then SideY:=I_S(ItemStrD(':',2,Par))
	    else SideY:=SideX;
	   end;
	 end; 
    'T': toCdM2:=R_S(Par);
    'W': CCDw:=R_S(Par);
	  
    end;
    ParFlag:=' ';    
   end
  else
   begin 
  Par:=__cvtstr(Par,_To_UpCase_Str);
 if {(Par[1]='/') or} (Par[1]='-') then
  begin
   Par:=copy(Par,2,length(par)-1);
   ParOrig1:=copy(ParOrig,2,length(par)-1);
  end 
 else 
   Par:='@'+ParOrig;  {should be the name of MainFrame, auxiliary @ is added}
  case Par[1] of
   '?','-','H': Help; {- added to respect unix --help even without the help}
   'B': if length(par)=1 then ParFlag:='B' else
	begin
         Par:=copy(Par,2,length(par)-1);
	 k:=ItemCountD(':',Par);
         if k>0 then LinMin:=I_S(ItemStrD(':',1,Par));
         if k>1 then LinMax:=I_S(ItemStrD(':',2,Par));
	end;
   'C': if length(par)=1 then ParFlag:='C' else
          if Par='CFUJI' then fuji:=true
	  else if Par='CYCGM' then YCGM:=true 
	  else    for k:=1 to 4 do
	  cam[k]:=I_S(copy(Par,k+1,1));
 {file names are upcased this way.... not very good}
   'D': if length(par)=1 then ParFlag:='D' else
        DarkFrame:=copy(ParOrig1,2,length(par)-1);
   'E': if length(par)=1 then ParFlag:='E' else
        EpsFile:=copy(ParOrig1,2,length(par)-1);
   'F': if length(par)=1 then ParFlag:='F' else
          for k:=2 to length(par) do
	   case Par[k] of
	    'A': begin Medians:=false; Luminance:=true; end;
	    'T': begin Luminance:=false; Medians:=false; end;
	    'M': Medians:=true;
	    'L': Luminance:=true;
	   end;     
   'G': begin 
         SumGlare:=true;
         if length(par)>1 then
	  begin
           Par:=copy(Par,2,length(par)-1);
	   k:=ItemCountD(':',Par);
           if k>0 then SeePX:=I_S(ItemStrD(':',1,Par));
           if k>1 then SeePY:=I_S(ItemStrD(':',2,Par));
	  end;  
	end;
   'I': if length(par)=1 then ParFlag:='I' else
        InfoFile:=copy(ParOrig1,2,length(par)-1);
   'L': if length(par)=1 then ParFlag:='L' else
	begin
         Par:=copy(Par,2,length(par)-1);
         minL:=R_S(Par);
	end;
   'M': begin
         Par:=copy(Par,2,length(par)-1);
	 k:=ItemCountD(':',Par);
         for i:=1 to k do 
          LumM[i]:=R_S(ItemStrD(':',i,Par));
	 LumMSet:=true; 
	end;
   'N': if length(par)=1 then ParFlag:='N' else
        LogImage:=copy(ParOrig1,2,length(par)-1);
   'O': if length(par)=1 then ParFlag:='O' else
        Ovlim:=I_S(copy(Par,2,length(par)-1));
   'P': if length(par)=1 then ParFlag:='P' else
        shrB:=I_S(copy(Par,2,1));
   'R': NonLinear:=true; {an option for computing radiances from DMSP data}
   'S': if length(par)=1 then ParFlag:='S' else
         begin
          Par:=copy(Par,2,length(par)-1);
          k:=ItemCountD(':',Par);
          if k>0 then 
	   begin
	    SideX:=I_S(ItemStrD(':',1,Par));
            if k>1 then SideY:=I_S(ItemStrD(':',2,Par))
	    else SideY:=SideX;
	   end;
	 end; 
   'T': if length(par)=1 then ParFlag:='T' else
        toCdM2:=R_S(copy(Par,2,length(par)-1));
   'U': if length(par)=1 then ParFlag:='U' else
        begin
         Par:=copy(Par,2,length(par)-1);
         maxL:=R_S(Par);
	end;
   'W': if length(par)=1 then ParFlag:='W' else
        CCDw:=R_S(copy(Par,2,length(Par)-1));
   '@': MainFrame:=ParOrig;
  end; {of case}
   end; {of ParFlag<>' '}
 end; {of for}

{writeln(cam[1],cam[2],cam[3],cam[4]);}

 fillchar(his,4*4*(trueov+1),0);
 fillchar(hisd,4*4*(trueov+1),0);
 fillchar(hist,4*4*(trueov+1)*(tilenC+1),0);

 if LumMset then
  if YCGM then
   begin
    Ym:=LumM[1]; Cm:=LumM[2]; GYm:=LumM[3]; Mm:=LumM[4];
   end  
  else 
   begin
    Rm:=LumM[1]; Gm:=LumM[2]; Bm:=LumM[3];
    R2R:=1; B2B:=1;
   end
 else if fuji then 
  begin
   R2R:=R2Rs5000; 
   B2B:=B2Bs5000; 
  end;  

 assign(f,MainFrame);
 FileMode:=0; {will open the files by reset as Read Only}


 FSplit(MainFrame,FDir,FName,FExt);


 if FExt='.pgm' then
  begin
   BitmapStart:=0;
 {$I-}
   assign(f1t,MainFrame);
   reset(f1t);
   if ioresult<>0 then
     begin writeln('The Main Frame not found.'); close(f1t); exit; end;
   {BUT STILL FAILS IF THE FILE NAME BEGINS WITH    CAPS   !} 
 {$I+}

   readln(f1t,auxstr); 
   if not (auxstr='P5') then 
    begin writeln('not a 16-bit PGM'); close(f1t); exit; end
   else   
    inc(BitmapStart,length(auxstr) + 1{for unix files}); 


   repeat readln(f1t,auxstr);
    inc(BitmapStart,length(auxstr) + 1{for unix files}); 
   until auxstr[1]<>'#';
   linl:=I_S(ItemStr(1,auxstr));
   lines:=I_S(ItemStr(2,auxstr)) div 2;


   repeat readln(f1t,auxstr);
    inc(BitmapStart,length(auxstr) + 1{for unix files});
    if pos(' = black',auxstr)>0 then  
     begin
      DarkConst:=I_S(ItemStr(2,auxstr)) shr shrB; 
      {needing a special format 
      # <black> = black }
     end;
   until auxstr[1]<>'#';

{writeln(auxstr);}
   if not (LI_S(auxstr)>255) then
    begin bytesPP:=1; startline:=0; DarkStrip:=false; end;
   if LI_S(auxstr)=65535 then
    begin startline:=0; DarkStrip:=false; end; 
   {as DarkStrip files, just those with 4095 upper limit 
    and similar are concerned, as for D60 special format}
  
   close(f1t);

{ startline = 12; for EOS D60}
   lines := lines - (StartLine div 2);
   tilerm := lines div sideY + 1;
   linlh :=  linl div 2 - 1 ; 

{ Fuji S5000 values, for some wide-angle setting:
Resolution   : 2816 x 2120
Flash used   : No
Focal length :  7.5mm  (35mm equivalent: 23mm)
CCD width    : 11.71mm
}

{writeln('lines ',lines,
' tilerm ',tilerm,
' linl ',linl,
' linlh ',linlh,
' tilen ',tilen,
' side ', side);
}

  reset(f,1);
  end
 else        
  reset(f,linl*bytesPP); 
  {the second case is for reading the data from the output of ``decompress'', 
   a graymap with no heading}

 tilen := (linlh+1) div sideX; 
 if tilen>tilenc then
    begin 
     writeln(
      'Please, choose a larger tile size, to have less than 100 tiles a row');
     halt;
    end;       
 if linlh>linlhC then
    begin 
     writeln(
      'Sorry, maximum line length is linlhC',linlhC*2:6,
      ' change this constant in source code if more is needed.');
     halt;
    end;       
 if (linlh+1) mod sideX = 0 then dec(tilen); 
 if LinMax=0 then LinMax:=lines;

if DarkFrame<>'' then
 begin
  assign(fd,DarkFrame);

  FSplit(DarkFrame,FDir,FName,FExt);

  if FExt='.pgm' then
   begin
    BitmapStartD:=0;   {seeking the end of heading}
 {$I-}
    assign(f1t,DarkFrame);
    reset(f1t);
    if ioresult<>0 then
     begin writeln('The Dark Frame not found.'); close(f1t); exit; end;
    {BUT STILL FAILS IF THE FILE NAME BEGINS WITH    CAPS   !} 
 {$I+}

    readln(f1t,auxstr); 
    if not (auxstr='P5') then 
     begin writeln('not a 16-bit PGM'); close(f1t); exit; end
    else   
     inc(BitmapStartD,length(auxstr) + 1{for unix files}); 


    repeat readln(f1t,auxstr);
     inc(BitmapStartD,length(auxstr) + 1{for unix files}); 
    until auxstr[1]<>'#';

    repeat readln(f1t,auxstr);
     inc(BitmapStartD,length(auxstr) + 1{for unix files});
    until auxstr[1]<>'#';

    close(f1t); 
    reset(fd,1)
   end
  else        
   reset(fd,linl*bytesPP); 
   {the second case is for reading the data from the output of ``decompress'', 
   a graymap with no heading}
  SubDF:=true;  
 end {of if DarkFrame<>'' then}
else
 DarkDF:=DarkConst; 

 writeln(cl,
'Results of "raw2lum" (version ', version,') with parameters:',cl,
' ',CommandLine);

 
if InfoFile<>'' then 
 begin
 {$I-}
  assign(fdesc,InfoFile);
  reset(fdesc);
  if ioresult<>0 then
   begin writeln('The Info File not found.'); close(fdesc); exit; end;
   {BUT STILL FAILS IF THE FILE NAME BEGINS WITH    CAPS   !} 
 {$I+}
  repeat 
   readln(fdesc,tline);
   tline13:=copy(tline,1,13);
   if tline13 =  
    'Exposure time' then 
     begin
      if ItemCountD('(',tline)=2 then
       begin
        auxstr:=ItemStrD('(',2,tline);
        auxstr:=ItemStrD(')',1,auxstr);
        auxstr:=ItemStrD('/',2,auxstr);
	exp_frac:=I_S(auxstr);
	if exp_frac=0 then exp_length:=0 else exp_length:=1.0/exp_frac; 
       end	
      else
       begin
        auxstr:=ItemStrD(':',2,tline);
        auxstr:=ItemStrD(' ',1,auxstr);
	exp_length:=R_S(auxstr);
       end;            	
      writeln('# ',tline); 
     end
   else 
  if tline13 =  
    'Aperture     ' then 
     begin
     if ItemCountD('/',tline)=2 then
       begin
        auxstr:=ItemStrD('/',2,tline);
	foc_ratio:=R_S(auxstr);
       end;            	
      writeln('# ',tline); 
     end
  else
  if tline13 =  
    'ISO equiv.   ' then 
     begin
      if ItemCountD(':',tline)=2 then
       begin
        auxstr:=ItemStrD(':',2,tline);
	ISO :=I_S(auxstr);
       end;            	
      writeln('# ',tline); 
     end
  else 
  if tline13 =  
    'Date/Time    ' then 
     begin
      writeln('# ',tline); 
     end
  else
  if tline13 =  
    'Focal length ' then 
     begin
      writeln('# ',tline); 
        auxstr:=ItemStrD(':',2,tline);
        auxstr:=ItemStrD('m',1,auxstr);
	TrueFocalLength:=R_S(auxstr);
     end
  else     
  if tline13 =  
    'Resolution   ' then 
     begin
      if fuji then
       writeln('# ',tline, ' in jpeg (',linl,'x',lines,' in ',MainFrame,')')
      else 
       writeln('# ',tline, ' in jpeg (',linl,'x',lines*2,' in ',MainFrame,')')
     end
  else     
  if tline13 =  
    'CCD width    ' then 
     begin
      write('# ',tline); 
      if CCDw>0 then 
       write(' (in jpg, but ', CCDw:5:2,' assumed further)');
      writeln; 
      auxstr:=ItemStrD(':',2,tline);
      auxstr:=ItemStrD('m',1,auxstr);
      CCDwidth:=R_S(auxstr);
     end;
       
            
  until eof(fdesc);
  exposure_known:= (exp_length>0) and (foc_ratio>0) and (ISO>0);
  if exposure_known then
   exposure:=ISO*exp_length/sqr(foc_ratio);
  tolumflux:=1/exposure;
  close(fdesc);
 end;  

 if CCDw>0 then CCDwidth:=CCDw; 
  {overriding the Exif info, 
    seems to be double the true one for S5000 files 
    converted to jpeg by winsoft}

 PixAngSizeKnown:=(TrueFocalLength>0) and (CCDwidth>0);
 if PixAngSizeKnown then
  begin
  if D60ThumbExif then 
   begin
    FourPixXS:=DoublePixSize/TrueFocalLength;
    FourPixYS:=FourPixXS;
   end    
  else if fuji then {45 degrees rotated matrix}
   begin
    FourPixXS:=CCDwidth*2 /(linl*TrueFocalLength);
    FourPixYS:=CCDwidth   /(linl*TrueFocalLength)
   end    
  else 
   begin
    FourPixXS:=CCDwidth*2 /(linl*TrueFocalLength);
    FourPixYS:=FourPixXS;
   end;
  FourPixSA:=FourPixXS*FourPixYS;
  SpaceAngle:=FourPixSA*lines*linl/2;
  XpToD:=FourPixXS*180/pi;
  YpToD:=FourPixYS*180/pi;
  if SeePX=0 then SeePX:=linl/4;
  if SeePY=0 then SeePY:=lines/2;
  end
 else FourPixSA:=1;    	    

 SumGlare:=SumGlare and PixAngSizeKnown;

 lnstep:=ln(10)/5;
 LogBase:=ln(BaseLum);
 tolum:=tolumflux/toCdM2;

{ to enable luminance computation during reading of data}
 if SubDF then 
   darkE:=darkDF
 else if DarkStrip then
   darkE:=130 {a VERY crude estimate for D60, 
               can be at least 127 to 133...}
 else    
   darkE:=DarkConst; {as taken from the heading of pgm file}
 
{ to speed up the computation:}
 R2T:=R2R*Rm*tolum;
 B2T:=B2B*Bm*tolum;
 G2T:=0.5*Gm*tolum;
 dark2:=2*darkE;
 
 if LogImage<>'' then
  begin
   MakeLogImage:=true;
   assign(LogImFile,LogImage);
   rewrite(LogImFile,1);
   if fuji then
    auxstr:='P6'+#10+SI(4,linl +10  )+SI(5,lines)+#10+'255'+#10
   else
    auxstr:='P6'+#10+SI(4,linl div 2 +10 )+SI(5,lines)+#10+'255'+#10;
   BlockWrite(LogImFile,auxstr[1],length(auxstr));
  end;


 for tile:=0 to tilen do
  for j:=1 to 4 do zerosums;

if DoTiles then
 captions;     

if Fext='.pgm' then
 seek(f,BitmapStart+linl*bytesPP*startline)
else 
 seek(f,startline);

if SubDF then
if Fext='.pgm' then
 seek(fd,BitmapStartD+linl*bytesPP*startline)
else 
 seek(fd,startline);


repeat

 if Fext='.pgm' then
  begin
   BlockRead (f,line1,linl*bytesPP);
   BlockRead (f,line2,linl*bytesPP);
  end
 else
  begin 
   BlockRead (f,line1,1);
   BlockRead (f,line2,1);
  end; 

 if SubDF then
  if Fext='.pgm' then
   begin
    BlockRead (fd,lineD1,linl*bytesPP);
    BlockRead (fd,lineD2,linl*bytesPP);
   end
  else
   begin 
    BlockRead (fd,lineD1,1);
    BlockRead (fd,lineD2,1);
   end; 

 inc(lin);
 InLines:= (lin>=linmin) and (lin<=linmax); 

 for i:=0 to linlh do {processing the double line}
  begin
   tile:=i div sideX;
   twoI:=2*i;
   
   if fuji then
   begin 
    if lin mod 2 = 0 then 
     begin
     v[1]:= line1[i,2]; {R}
     v[2]:= line2[i,1]; {G}
     v[3]:= line2[i,2]; {G2}
     v[4]:= line1[i,1]; {B}
     end 
    else
     begin
     v[1]:= line1[i,1];  {R}
     v[2]:= line2[i,1]; {G}
     v[3]:= line2[i,2]; {G2}
     v[4]:= line1[i,2]; {B}
    end
   end
   
   else if bytesPP=2 then
   begin
   v[1]:= line1[i,1];  {R}
   v[2]:= line1[i,2]; {G}
   v[3]:= line2[i,1]; {G2}
   v[4]:= line2[i,2]; {B}
   end else
   begin
   v[1]:= line1B[i,1];  {R}
   v[2]:= line1B[i,2]; {G}
   v[3]:= line2B[i,1]; {G2}
   v[4]:= line2B[i,2]; {B}
   end;

   if (Fext='.pgm') and (bytesPP=2) then
    for j:=1 to 4 do 
     v[j]:=swap(v[j]) shr shrB;

   if SubDF then
   begin 
   if fuji then
   begin 
    if lin mod 2 = 0 then 
     begin
     vD[1]:= lineD1[i,2]; {R}
     vD[2]:= lineD2[i,1]; {G}
     vD[3]:= lineD2[i,2]; {G2}
     vD[4]:= lineD1[i,1]; {B}
     end 
    else
     begin
     vD[1]:= lineD1[i,1];  {R}
     vD[2]:= lineD2[i,1]; {G}
     vD[3]:= lineD2[i,2]; {G2}
     vD[4]:= lineD1[i,2]; {B}
    end
   end
   else if bytesPP=2 then
    begin     
     vD[1]:= lineD1[i,1];  {R}
     vD[2]:= lineD1[i,2]; {G}
     vD[3]:= lineD2[i,1]; {G2}
     vD[4]:= lineD2[i,2]; {B}
    end else
    begin     
     vD[1]:= lineD1B[i,1];  {R}
     vD[2]:= lineD1B[i,2]; {G}
     vD[3]:= lineD2B[i,1]; {G2}
     vD[4]:= lineD2B[i,2]; {B}
    end;

   if (Fext='.pgm') and (bytesPP=2) then
      for j:=1 to 4 do 
       vD[j]:=swap(vD[j]) shr shrB;
   end;    


   {if (lin=1) then 
    writeln(i:3, v[1]:5, v[2]:5, v[3]:5, v[4]:5, nsum[1][tile]:5);}
   Overfull:=false;

   for j:=1 to 4 do 
    begin

     o[j]:=(v[j]>=ovlim); {is overfull}

     if SubDF then 
      begin
       auxint:=v[j]+darkDF-vD[j];  
       if auxint>0 then v[j]:=auxint else v[j]:=0;
      end; 

     if not(o[j]) then
      begin
        {dark-frame pixel value is subtracted 
	 and darkDF added to be over zero for sure;
	 overfull pixels are left at original values} 
       if (i>0) or (not DarkStrip) then 
          {the first double-column is ignored, as too white for D60} 
        begin
	 if v[j]>0 then
          if not NonLinear then
           sum[j][tile]:= sum[j][tile] + v[j]
          else
           sum[j][tile]:= sum[j][tile] + round(exp(ln(v[j])*1.5));
         inc(nsum[j][tile]);
        end	
      end
     else {when overfull}
      begin
       inc(osum[j][tile]);
       Overfull:=true;
      end; 
      
     if v[j] < minv[j][tile] then minv[j][tile]:=v[j];
     if v[j] > maxv[j][tile] then maxv[j][tile]:=v[j];

     if DarkStrip and (tile = 0) then 
      begin if i>0 then inc(hisd[j][v[j]]) end 
            {the first double-column is ignored}
     else 
      begin
       inc(his[j][v[j]]);
      end; 
     if DoTiles then inc(hist[j,v[j],tile]); 
{writeln(j:1,v[j]:4,tile:3,hist[j,v[j],tile]:3);}
    end; {of summing the four pixel values}
 
   if (not Overfull) then {none of the four pixels >= ovlim}
    if not NonLinear then
     begin
      if YCGM then
	 L:=  (Ym*(v[cam[1]]-darkE) 
              +Cm*(v[cam[2]]-darkE)
	      +GYm*(v[cam[3]]-darkE)
              +Mm*(v[cam[4]]-darkE) 
 	      )*tolum
      else 
       L:=
        R2T*(v[cam[1]] - darkE)+
        G2T*(v[cam[2]]+v[cam[3]] - dark2)+
        B2T*(v[cam[4]] - darkE) ;
      Overfull:=Overfull or (L<minL) or (L>maxL)
     end 
    else {just for gray DMSP data}
     begin
      L:=0;
      for j:=1 to 4 do
       if v[j]>0 then L:=L+ exp(ln(v[j])*1.5);
      L:=L*tolum; 
     end;
     
   if (not Overfull) and InLines then 
    begin
      lsum:=lsum+L;  
      if SumGlare then 
       begin 
        SqAngDist:= sqr((i-SeePx)*XpToD)+sqr((lin-SeePy)*YpToD) ;
        if SqAngDist>0.1 then
         VeiLum:=VeiLum+L/SqAngDist;
       end;	 
      if MakeLogImage then 
       begin 
         if L<BaseLumMin then 
          if fuji then
    	   fillchar(LogCol[twoI][1],6,0)
          else  
           fillchar(LogCol[i][1],3,0)
	 else
	  begin
           LogLR:=(ln(L)-LogBase)/lnstep;
           if LogLR>39 then LogLR:=39;
	   LogL:=round(LogLR);
           if fuji then
            for j:=1 to 3 do
	     begin  
              LogCol[twoI][j]:=
               colorLog[LogL div colors][j] * pow2m1[LogL mod colors];
              LogCol[twoI+1][j]:=LogCol[twoI][j];
	      {doubling the pixels to preserve the aspect ratio}
             end	       
	   else
            for j:=1 to 3 do  
             LogCol[i][j]:=
	      colorLog[LogL div colors][j] * pow2m1[LogL mod colors];
	  end; 
       end;	 
    end
   else {is Overfull} 
    if MakeLogImage then 
     if fuji then
      fillchar(LogCol[twoI][1],6,0)
     else  
      fillchar(LogCol[i][1],3,0);
  end;  {of processing the double line}

if MakeLogImage then 
 begin
  if fuji then
   inc(twoI,2)
  else   
   twoI:=twoI div 2 + 1;
  LogL:=((40*lin)-1) div lines;
  for j:=1 to 3 do
   begin 
    LogCol[twoI][j]:=
     colorLog[LogL div colors][j] * pow2m1[LogL mod colors];
   for i:=1 to 9 do       
    LogCol[twoI+i][j]:=LogCol[twoI][j];
   end;  
  if fuji then
   BlockWrite(LogImFile,LogCol,3*(linl +10 ))
  else  
   BlockWrite(LogImFile,LogCol,3*(linl div 2 +10 ));
 end; 

if DoTiles and (lin mod sideY = 0) then 
 begin
{ for j:=1 to 4 do writeln(his[j][0]); }
  PrintTiles
 end; 

until lin=lines;

close(f); 
if SubDF then close(fd); 

if MakeLogImage then close(LogImFile); 

if DoPrintTiles and (lin mod sideY > 0)  then PrintTiles;

if EpsFile<>'' then
 begin
  writeln(draw,cl,'showpage');
  close(draw);
 end;


if darkN>0 then {darkN>0 = DarkStrip} 
 begin
  darkFloat:= 1.0* dark / darkN;
  dark:=dark div darkN;
 end;  
if not DarkStrip then {black should be set by the heading of pgm}
 begin
  {darkStripVal:=darkDF;}
  dark:=darkDF;
  darkFloat:=dark;
 end;
if SubDF then dark:=darkDF
{else darkDF:=darkConst};

for j:=1 to 4 do 
 begin
  if mint[j]<min then min:=mint[j];
  if maxt[j]>max then max:=maxt[j];
 end; 


for j:=1 to 4 do
 begin
  count:=sumN[j]+osumt[j];
  if DarkStrip then
   begin
    if count <> lines*(linlh+1-sideX) then writeln('# Queer count: ', count)
   end
  else 
   if count <> lines*(linlh+1) then writeln('# Queer count: ', count);
  for k:=1 to percn do
   begin
    perc[j][k]:=trunc(0.01*percv[k]*count);
   end;    
 end;


if PrintHistogram then
 begin
  writeln;
  writeln('# Image histogram, lossless');
  if YCGM then
   writeln(
   '# value   Y      C      G      M   counts ') 
  else
   writeln(
   '# value   R     G1     G2      B   counts ');
 end;

for i:=min to max do
 begin
  nonzero:=false;
  for j:=1 to 4 do
   nonzero:=nonzero or (his[j][i]>0);
  if nonzero then 
  begin
   overdark:=i;
   dec(overdark,dark);
   if PrintHistogram then write(overdark:4);
   for j:=1 to 4 do
    begin
     if PrintHistogram then write(his[j][i]:7);
     inc(dist[j], his[j][i]);
     if kf[j]<=percn then
      if dist[j]>=perc[j][kf[j]] then 
       repeat
        perc[j][kf[j]]:=i;
        inc(kf[j]);
       until (dist[j]<perc[j][kf[j]]) or (kf[j]>percn);
    end;
   if PrintHistogram then writeln;
  end;       
 end;  

for j:=1 to 4 do
    while kf[j]<=percn do {for case of max-min<percn}
     begin
      perc[j][kf[j]]:=i {=max} ;
      inc(kf[j]);
     end; 

if PrintHistogram 
and DarkStrip then
 begin
  writeln;
  writeln('# Dark strip histogram, lossless');
  if YCGM then
   writeln('# value  Y     C     G     M   counts')
  else
   writeln('# value  R    G1    G2     B   counts');


  for i:=darkmin to darkmax do
   begin
    nonzero:=false;
    for j:=1 to 4 do
     nonzero:=nonzero or (hisd[j][i]>0);
    if nonzero then 
     writeln(i-dark:4, hisd[1][i]:6, hisd[2][i]:6, hisd[3][i]:6, hisd[4][i]:6);
   end;
 end;
 
writeln; 
write('# Image percentils         ');
if exposure_known then 
if YCGM then
write('L=(',Ym:4:2,'*Y+',Cm:4:2,'*C+',GYm:4:2,'*G+',Mm:4:2,'*M)*',
       SRx(2,1/(exposure*toCdM2)))
else
write('L=(',R2R:5:3,'*',Rm:4:2,'*R+',Gm:4:2,'*G+',B2B:5:3,'*',Bm:4:2,'*B)*',
       SRx(2,1/(exposure*toCdM2)));
writeln;
if YCGM then
write(
'# %    Y     C     G     M readings')
else
write(
'# %    R     G1    G2    B readings');

if exposure_known then 

if YCGM then
write(                              '  L / cd/m2')
else
write(                              '  R        G        B        L / cd/m2');

writeln; 
for k:=1 to percn do
 begin
  write(percv[k]:3);
  for j:=1 to 4 do
   begin
    write(perc[cam[j]][k] - dark :6);
   end;
  if exposure_known then
if YCGM then
    begin
	   L:=(Ym*(perc[cam[1]][k] - darkFloat) 
              +Cm*(perc[cam[2]][k] - darkFloat)
	      +GYm*(perc[cam[3]][k] - darkFloat)
              +Mm*(perc[cam[4]][k] - darkFloat) 
	      ) * tolumflux ;
    write('      ',
	  SRxb(1,L/toCdM2,7) );
   end	      
else
   begin
    R:=R2R*(perc[cam[1]][k] - darkFloat)  /exposure ;
    G:=0.5  *(perc[cam[2]][k]+perc[cam[3]][k] - 2*darkFloat)/exposure ;
    B:=B2B*(perc[cam[4]][k] - darkFloat) /exposure  ;
    L:=Rm*R + Gm*G + Bm*B;
    write('        ',
          SRxb(1,R/toCdM2,7), '  ' ,
          SRxb(1,G/toCdM2,7), '  ' ,
	  SRxb(1,B/toCdM2,7), '  ' ,
	  SRxb(2,L/toCdM2,7) );
   end;	  
  writeln; 
 end;

  if exposure_known then
if YCGM then
   begin
    if PixAngSizeKnown then
     write('# (some illum) from',SpaceAngle:5:2,' sr')
    else
     write('# (some illum) from ??? sr');
    writeln(
	  SRxb(1,FourPixSA*Lsum,7) );
    if NonLinear then 
     writeln('# and average luminance is', SRx(3,FourPixSA*Lsum/SpaceAngle)); 	  
   end	      
else
   begin 
    if PixAngSizeKnown then
     begin
      if SumGlare then
       write('# veiling luminance ',SRxb(1,18*VeiLum*FourPixSA,6),' cd/m2,')
      else write('#');
      write(' flux from',SpaceAngle:5:2,' sr (',SRx(2,FourPixSA),' sr/4px) is ')
     end
    else
     write('# flux from ??? sr');
    write(
	  SRxb(2,FourPixSA*Lsum,7) );
    if NonLinear then 
     writeln('# and average luminance is', SRx(3,FourPixSA*Lsum/SpaceAngle)); 	  
    if maxL=maxLC then	
     if minL=minLC then 
      writeln(' (summing all pixels below ',ovlim:5,')')
     else  
      writeln(' (points with luminances over ',SRxb(1,minL,7),')')
    else
     if minL=minLC then
      writeln(' (points with luminances below ',SRxb(1,maxL,7),')')
     else
      writeln(' (points with luminances over ',SRxb(1,minL,7),
                                 ' and below ',SRxb(1,maxL,7),')');
   end
 else  
   writeln; 

if DarkStrip then
 if SubDF then
  writeln('# DarkStrip av.=',darkFloat-dark : 5:1,
        '  min.=', darkmin-dark :5, '  max.=',darkmax-dark : 5,
        ' (dark frame ', DarkFrame, ' subtracted from all values)')
 else
  writeln('# dark average=',darkFloat : 5:1,
        '  minimum=', darkmin-dark :5, '  maximum=',darkmax-dark : 5,
        ' (dark is subtracted from the other data)')
else
 if SubDF then 
  writeln('# dark frame ', DarkFrame, ' has been subtracted from all values')
 else
  writeln('# dark=',dark, ' has been substracted from all values'); 
	                
for j:=1 to 4 do 
 begin
  if YCGM then
   write('# ',colorY[j])
  else 
   write('# ',color[j]);
   writeln(              ' average=',sumt[cam[j]] / sumN[cam[j]] - dark: 5:0,
        '  minimum=', mint[cam[j]] - dark:5, '  maximum=',maxt[cam[j]] - dark : 5, 
	'   over ',ovlim :4,': ', osumt[j]:3);                
 end;

writeln(cl,
 'End of results of "raw2lum" (version ', version,') with parameters:',cl,
 ' ',CommandLine);

end.      
